# Generated by ariadne-codegen
# Source: combined.graphql

from datetime import datetime
from typing import Any, List, Optional
from uuid import UUID

from pydantic import Field

from .base_model import BaseModel
from .enums import ModuleFailureReason, ModuleInstanceStatus, ModuleInstanceTarget


class ArgumentFull(BaseModel):
    id: UUID
    name: Optional[str]
    typeinfo: Any
    value: Optional[Any]
    created_at: datetime
    rejected_at: Optional[datetime]
    source: Optional[UUID]
    tags: Optional[List[str]]


class ModuleFull(BaseModel):
    id: UUID
    name: Optional[str]
    created_at: datetime
    deleted_at: Optional[datetime]
    path: str
    ins: List[Any]
    ins_usage: Optional[List[str]]
    outs: List[Any]
    outs_usage: Optional[List[str]]
    description: Optional[str]
    typedesc: str
    tags: Optional[List[str]]
    targets: List[ModuleInstanceTarget]
    resource_bounds: Optional["ModuleFullResourceBounds"]


class ModuleFullResourceBounds(BaseModel):
    gpu_min: Optional[int]
    gpu_max: Optional[int]
    gpu_hint: Optional[int]
    gpu_mem_min: Optional[int]
    gpu_mem_max: Optional[int]
    gpu_mem_hint: Optional[int]
    cpu_min: Optional[int]
    cpu_max: Optional[int]
    cpu_hint: Optional[int]
    node_min: Optional[int]
    node_max: Optional[int]
    node_hint: Optional[int]
    mem_min: Optional[int]
    mem_max: Optional[int]
    storage_min: Optional[int]
    storage_max: Optional[int]


class ModuleInstanceCommon(BaseModel):
    id: UUID
    account_id: UUID
    name: Optional[str]
    created_at: datetime
    deleted_at: Optional[datetime]
    queued_at: Optional[datetime]
    admitted_at: Optional[datetime]
    dispatched_at: Optional[datetime]
    completed_at: Optional[datetime]
    path: str
    status: ModuleInstanceStatus
    target: ModuleInstanceTarget
    tags: Optional[List[str]]
    failure_reason: Optional[ModuleFailureReason]
    failure_context: Optional["ModuleInstanceCommonFailureContext"]


class ModuleInstanceCommonFailureContext(BaseModel):
    stdout: Optional[str]
    stderr: Optional[str]
    syserr: Optional[str]


class ModuleInstanceFull(ModuleInstanceCommon):
    ins: List["ModuleInstanceFullIns"]
    outs: List["ModuleInstanceFullOuts"]
    resources: Optional["ModuleInstanceFullResources"]
    progress: Optional["ModuleInstanceFullProgress"]
    resource_utilization: Optional["ModuleInstanceFullResourceUtilization"]


class ModuleInstanceFullIns(BaseModel):
    id: UUID
    created_at: datetime
    deleted_at: Optional[datetime]
    rejected_at: Optional[datetime]
    account_id: UUID
    typeinfo: Any
    value: Optional[Any]
    tags: Optional[List[str]]
    source: Optional[UUID]


class ModuleInstanceFullOuts(BaseModel):
    id: UUID
    created_at: datetime
    deleted_at: Optional[datetime]
    rejected_at: Optional[datetime]
    account_id: UUID
    typeinfo: Any
    value: Optional[Any]
    tags: Optional[List[str]]
    source: Optional[UUID]


class ModuleInstanceFullResources(BaseModel):
    gpus: Optional[int]
    nodes: Optional[int]
    mem: Optional[int]
    storage: Optional[int]
    walltime: Optional[int]


class ModuleInstanceFullProgress(BaseModel):
    n: int
    n_expected: int
    n_max: int
    done: bool


class ModuleInstanceFullResourceUtilization(BaseModel):
    gpu: Optional[float]
    mem: Optional[float]
    storage: float
    walltime: float
    cputime: float
    inodes: float
    sus: Optional[int]


class PageInfoFull(BaseModel):
    has_previous_page: bool = Field(alias="hasPreviousPage")
    has_next_page: bool = Field(alias="hasNextPage")
    start_cursor: Optional[str] = Field(alias="startCursor")
    end_cursor: Optional[str] = Field(alias="endCursor")


ArgumentFull.model_rebuild()
ModuleFull.model_rebuild()
ModuleInstanceCommon.model_rebuild()
ModuleInstanceFull.model_rebuild()
PageInfoFull.model_rebuild()
